; Written by Imran S. Haque (ihaque@cs.stanford.edu)
;
; Copyright (c) 2011 Stanford University.
; All rights reserved.
;
; Redistribution and use in source and binary forms, with or without modification,
; are permitted provided that the following conditions are met:
;
;     * Redistributions of source code must retain the above copyright notice,
;       this list of conditions and the following disclaimer.
;     * Redistributions in binary form must reproduce the above copyright notice,
;       this list of conditions and the following disclaimer in the documentation
;       and/or other materials provided with the distribution.
;     * Neither the name of Stanford University nor the names of its contributors
;       may be used to endorse or promote products derived from this software without
;       specific prior written permission.
;
; THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
; ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
; WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
; IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
; INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
; NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
; PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
; WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
; ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
; POSSIBILITY OF SUCH DAMAGE.

        BITS 64
        extern printf
%macro dumptsc 0
    rdtsc
    shl rdx,32
    or rax,rdx
    mov rsi,rax
    mov rdi,fmt
    mov rax,0
    call printf
%endmacro

%macro storetsc 1
    rdtscp
    shl rdx,32
    or rax,rdx
    movq %1,rax
%endmacro

%macro printtsc 1
    movq rsi,%1
    mov rdi,fmt
    mov rax,0
    call printf
%endmacro

%macro deltatsc 3
    psubq %2,%1
    movq rsi,%2
    mov rdi,%3
    mov rax,0
    call printf
%endmacro

%macro benchtsc 0
    storetsc xmm12
    storetsc xmm13
    deltatsc xmm12,xmm13,initfmt
%endmacro

%macro popcprologue 0
     mov rsi,str1
     mov rdi,str2
     mov rbx,qword [rsi]
     mov rcx,qword [rsi+8]
     mov rdx,qword [rsi+16]
     mov rbp,qword [rsi+24]
     mov r8,qword [rsi+32]
     mov r9,qword [rsi+40]
%endmacro
%macro popcbody 0
    ; the repeating unit of the popcnt benchmark
     and rbx,qword [rdi]
     and rcx,qword [rdi+8]
     popcnt rbx,rbx
     and rdx,qword [rdi+16]
     popcnt rcx,rcx
     and rbp,qword [rdi+24]
     popcnt rdx,rdx
     and r8,qword [rdi+32]
     popcnt rbp,rbp
     and r9,qword [rdi+40]
     popcnt r8,r8
     add rax,rbx
     mov r10,qword [rsi+48]
     popcnt r9,r9
     add rax,rcx
     mov r11,qword [rsi+56]
     add rax,rdx
     mov r12,qword [rsi+64]
     add rax,rbp
     mov r13,qword [rsi+72]
     add rax,r8
     mov r14,qword [rsi+80]
     add rax,r9
     mov r15,qword [rsi+88]

     and r10,[rdi+48]
     and r11,[rdi+56]
     popcnt r10,r10
     and r12,[rdi+64]
     popcnt r11,r11
     and r13,[rdi+72]
     popcnt r12,r12
     and r14,[rdi+80]
     popcnt r13,r13
     and r15,[rdi+88]
     popcnt r14,r14
     add rax,r10
     mov rbx,qword [rsi]
     popcnt r15,r15
     add rax,r11
     mov rcx,qword [rsi+8]
     add rax,r12
     mov rdx,qword [rsi+16]
     add rax,r13
     mov rbp,qword [rsi+24]
     add rax,r14
     mov r8,qword [rsi+32]
     add rax,r15
     mov r9,qword [rsi+40]
%endmacro   

%macro popcepilogue 0
    ; tail unit of the popc benchmark - doesn't do loads for next iteration
     and rbx,qword [rdi]
     and rcx,qword [rdi+8]
     popcnt rbx,rbx
     and rdx,qword [rdi+16]
     popcnt rcx,rcx
     and rbp,qword [rdi+24]
     popcnt rdx,rdx
     and r8,qword [rdi+32]
     popcnt rbp,rbp
     and r9,qword [rdi+40]
     popcnt r8,r8
     add rax,rbx
     mov r10,qword [rsi+48]
     popcnt r9,r9
     add rax,rcx
     mov r11,qword [rsi+56]
     add rax,rdx
     mov r12,qword [rsi+64]
     add rax,rbp
     mov r13,qword [rsi+72]
     add rax,r8
     mov r14,qword [rsi+80]
     add rax,r9
     mov r15,qword [rsi+88]

     and r10,[rdi+48]
     and r11,[rdi+56]
     popcnt r10,r10
     and r12,[rdi+64]
     popcnt r11,r11
     and r13,[rdi+72]
     popcnt r12,r12
     and r14,[rdi+80]
     popcnt r13,r13
     and r15,[rdi+88]
     popcnt r14,r14
     add rax,r10
     popcnt r15,r15
     add rax,r11
     add rax,r12
     add rax,r13
     add rax,r14
     add rax,r15
%endmacro

%macro popcbody24 0
    popcbody
    popcbody
    popcbody
    popcbody
    popcbody
    popcbody
    popcbody
    popcbody
    popcbody
    popcbody
    popcbody
    popcbody
    popcbody
    popcbody
    popcbody
    popcbody
    popcbody
    popcbody
    popcbody
    popcbody
    popcbody
    popcbody
    popcbody
    popcbody
%endmacro

%macro popcrun25 0
    popcbody24
    popcbody
%endmacro
%macro popcterminate25 0
    popcbody24
    popcepilogue
%endmacro

%macro benchpopc 0
    ; runs 3000 popcnt's worth of work, and prints elapsed clock cycles
    storetsc xmm12
    popcprologue
    popcrun25
    popcrun25
    popcrun25
    popcrun25
    popcrun25
    popcrun25
    popcrun25
    popcrun25
    popcrun25
    popcterminate25
    storetsc xmm13
    deltatsc xmm12,xmm13,efmt
%endmacro

        SECTION .data
        ; align to a cache line boundary
        align 64
        ; 128B strings, we only use 96B
str1: db "AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA"
str2: db "BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB"
fmt:    db "Hello World, clocks = %lld",10,0
initfmt:    db "store/printtsc latency, clocks = %lld",10,0
efmt:    db "latency for 3000 POPCNT+timing, clocks = %lld",10,0

    SECTION .text
    global main
main:
    push rbp
    benchtsc
    benchtsc
    benchtsc

bench:
    benchpopc
    jmp bench

    pop rbp
    mov rax,0
    ret
    
