/**************************************************************************

    Written by Imran Haque (ihaque@cs.stanford.edu) based on GPL3-licensed
    code (C) 2010 by Eli Lilly and Company

    Copyright (C) 2011 Stanford University


    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

**************************************************************************/

#include "precompbit8.h"

inline int popcount_8bit_LUT_1(unsigned* bufA,int nbytes) {
    unsigned char * byte_a = (unsigned char * ) bufA;
    int common = 0;
    for(int j =0; j<nbytes;++j)
    {
      common += eight_bit_count[(*byte_a)];
      ++byte_a;
    }
    return common;
}
inline int popcount_8bit_LUT_2(unsigned* bufA,unsigned* bufB,int nbytes) {
    unsigned char * byte_a = (unsigned char * ) bufA;
    unsigned char * byte_b = (unsigned char * ) bufB;
    int common = 0;
    for(int j =0; j<nbytes;++j)
    {
      common += eight_bit_count[(*byte_a) & (*byte_b)];
      ++byte_a;
      ++byte_b;
    }
    return common;
}
inline void popcount_8bit_LUT_2x1(const unsigned* bufR0,const unsigned* bufR1,const unsigned* bufB,int nbytes,int* counts) {
    unsigned char * byte_R0 = (unsigned char * ) bufR0;
    unsigned char * byte_R1 = (unsigned char * ) bufR1;
    unsigned char * byte_b = (unsigned char * ) bufB;
    counts[0] = 0; counts[1] = 0;
    unsigned char BB;
    for(int j =0; j<nbytes;++j)
    {
        BB = *byte_b;
        counts[0] += eight_bit_count[(*byte_R0) & BB];
        counts[1] += eight_bit_count[(*byte_R1) & BB];
        ++byte_R0;
        ++byte_R1;
        ++byte_b;
    }
    return;
}

inline int popcount_1fp(unsigned* buf,const int nwords) {
    return popcount_8bit_LUT_1(buf,nwords*4);
}
inline int popcount_2fp(unsigned* bufA,unsigned* bufB,const int nwords) {
    return popcount_8bit_LUT_2(bufA,bufB,nwords*4);
}
inline void popcount_2fp_2( unsigned* bufR0, unsigned* bufR1, unsigned* bufB, int nwords,int* counts) {
    popcount_8bit_LUT_2x1(bufR0,bufR1,bufB,nwords*4,counts);
    return;
}
