/**************************************************************************

    Copyright (C) 2010  Eli Lilly and Company

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

**************************************************************************/

static const unsigned char eight_bit_count[256] = {
    0,   /* 0 0 */
    1,   /* 1 1 */
    1,   /* 2 2 */
    2,   /* 3 3 */
    1,   /* 4 4 */
    2,   /* 5 5 */
    2,   /* 6 6 */
    3,   /* 7 7 */
    1,   /* 8 8 */
    2,   /* 9 9 */
    2,   /* 10 a */
    3,   /* 11 b */
    2,   /* 12 c */
    3,   /* 13 d */
    3,   /* 14 e */
    4,   /* 15 f */
    1,   /* 16 10 */
    2,   /* 17 11 */
    2,   /* 18 12 */
    3,   /* 19 13 */
    2,   /* 20 14 */
    3,   /* 21 15 */
    3,   /* 22 16 */
    4,   /* 23 17 */
    2,   /* 24 18 */
    3,   /* 25 19 */
    3,   /* 26 1a */
    4,   /* 27 1b */
    3,   /* 28 1c */
    4,   /* 29 1d */
    4,   /* 30 1e */
    5,   /* 31 1f */
    1,   /* 32 20 */
    2,   /* 33 21 */
    2,   /* 34 22 */
    3,   /* 35 23 */
    2,   /* 36 24 */
    3,   /* 37 25 */
    3,   /* 38 26 */
    4,   /* 39 27 */
    2,   /* 40 28 */
    3,   /* 41 29 */
    3,   /* 42 2a */
    4,   /* 43 2b */
    3,   /* 44 2c */
    4,   /* 45 2d */
    4,   /* 46 2e */
    5,   /* 47 2f */
    2,   /* 48 30 */
    3,   /* 49 31 */
    3,   /* 50 32 */
    4,   /* 51 33 */
    3,   /* 52 34 */
    4,   /* 53 35 */
    4,   /* 54 36 */
    5,   /* 55 37 */
    3,   /* 56 38 */
    4,   /* 57 39 */
    4,   /* 58 3a */
    5,   /* 59 3b */
    4,   /* 60 3c */
    5,   /* 61 3d */
    5,   /* 62 3e */
    6,   /* 63 3f */
    1,   /* 64 40 */
    2,   /* 65 41 */
    2,   /* 66 42 */
    3,   /* 67 43 */
    2,   /* 68 44 */
    3,   /* 69 45 */
    3,   /* 70 46 */
    4,   /* 71 47 */
    2,   /* 72 48 */
    3,   /* 73 49 */
    3,   /* 74 4a */
    4,   /* 75 4b */
    3,   /* 76 4c */
    4,   /* 77 4d */
    4,   /* 78 4e */
    5,   /* 79 4f */
    2,   /* 80 50 */
    3,   /* 81 51 */
    3,   /* 82 52 */
    4,   /* 83 53 */
    3,   /* 84 54 */
    4,   /* 85 55 */
    4,   /* 86 56 */
    5,   /* 87 57 */
    3,   /* 88 58 */
    4,   /* 89 59 */
    4,   /* 90 5a */
    5,   /* 91 5b */
    4,   /* 92 5c */
    5,   /* 93 5d */
    5,   /* 94 5e */
    6,   /* 95 5f */
    2,   /* 96 60 */
    3,   /* 97 61 */
    3,   /* 98 62 */
    4,   /* 99 63 */
    3,   /* 100 64 */
    4,   /* 101 65 */
    4,   /* 102 66 */
    5,   /* 103 67 */
    3,   /* 104 68 */
    4,   /* 105 69 */
    4,   /* 106 6a */
    5,   /* 107 6b */
    4,   /* 108 6c */
    5,   /* 109 6d */
    5,   /* 110 6e */
    6,   /* 111 6f */
    3,   /* 112 70 */
    4,   /* 113 71 */
    4,   /* 114 72 */
    5,   /* 115 73 */
    4,   /* 116 74 */
    5,   /* 117 75 */
    5,   /* 118 76 */
    6,   /* 119 77 */
    4,   /* 120 78 */
    5,   /* 121 79 */
    5,   /* 122 7a */
    6,   /* 123 7b */
    5,   /* 124 7c */
    6,   /* 125 7d */
    6,   /* 126 7e */
    7,   /* 127 7f */
    1,   /* 128 80 */
    2,   /* 129 81 */
    2,   /* 130 82 */
    3,   /* 131 83 */
    2,   /* 132 84 */
    3,   /* 133 85 */
    3,   /* 134 86 */
    4,   /* 135 87 */
    2,   /* 136 88 */
    3,   /* 137 89 */
    3,   /* 138 8a */
    4,   /* 139 8b */
    3,   /* 140 8c */
    4,   /* 141 8d */
    4,   /* 142 8e */
    5,   /* 143 8f */
    2,   /* 144 90 */
    3,   /* 145 91 */
    3,   /* 146 92 */
    4,   /* 147 93 */
    3,   /* 148 94 */
    4,   /* 149 95 */
    4,   /* 150 96 */
    5,   /* 151 97 */
    3,   /* 152 98 */
    4,   /* 153 99 */
    4,   /* 154 9a */
    5,   /* 155 9b */
    4,   /* 156 9c */
    5,   /* 157 9d */
    5,   /* 158 9e */
    6,   /* 159 9f */
    2,   /* 160 a0 */
    3,   /* 161 a1 */
    3,   /* 162 a2 */
    4,   /* 163 a3 */
    3,   /* 164 a4 */
    4,   /* 165 a5 */
    4,   /* 166 a6 */
    5,   /* 167 a7 */
    3,   /* 168 a8 */
    4,   /* 169 a9 */
    4,   /* 170 aa */
    5,   /* 171 ab */
    4,   /* 172 ac */
    5,   /* 173 ad */
    5,   /* 174 ae */
    6,   /* 175 af */
    3,   /* 176 b0 */
    4,   /* 177 b1 */
    4,   /* 178 b2 */
    5,   /* 179 b3 */
    4,   /* 180 b4 */
    5,   /* 181 b5 */
    5,   /* 182 b6 */
    6,   /* 183 b7 */
    4,   /* 184 b8 */
    5,   /* 185 b9 */
    5,   /* 186 ba */
    6,   /* 187 bb */
    5,   /* 188 bc */
    6,   /* 189 bd */
    6,   /* 190 be */
    7,   /* 191 bf */
    2,   /* 192 c0 */
    3,   /* 193 c1 */
    3,   /* 194 c2 */
    4,   /* 195 c3 */
    3,   /* 196 c4 */
    4,   /* 197 c5 */
    4,   /* 198 c6 */
    5,   /* 199 c7 */
    3,   /* 200 c8 */
    4,   /* 201 c9 */
    4,   /* 202 ca */
    5,   /* 203 cb */
    4,   /* 204 cc */
    5,   /* 205 cd */
    5,   /* 206 ce */
    6,   /* 207 cf */
    3,   /* 208 d0 */
    4,   /* 209 d1 */
    4,   /* 210 d2 */
    5,   /* 211 d3 */
    4,   /* 212 d4 */
    5,   /* 213 d5 */
    5,   /* 214 d6 */
    6,   /* 215 d7 */
    4,   /* 216 d8 */
    5,   /* 217 d9 */
    5,   /* 218 da */
    6,   /* 219 db */
    5,   /* 220 dc */
    6,   /* 221 dd */
    6,   /* 222 de */
    7,   /* 223 df */
    3,   /* 224 e0 */
    4,   /* 225 e1 */
    4,   /* 226 e2 */
    5,   /* 227 e3 */
    4,   /* 228 e4 */
    5,   /* 229 e5 */
    5,   /* 230 e6 */
    6,   /* 231 e7 */
    4,   /* 232 e8 */
    5,   /* 233 e9 */
    5,   /* 234 ea */
    6,   /* 235 eb */
    5,   /* 236 ec */
    6,   /* 237 ed */
    6,   /* 238 ee */
    7,   /* 239 ef */
    4,   /* 240 f0 */
    5,   /* 241 f1 */
    5,   /* 242 f2 */
    6,   /* 243 f3 */
    5,   /* 244 f4 */
    6,   /* 245 f5 */
    6,   /* 246 f6 */
    7,   /* 247 f7 */
    5,   /* 248 f8 */
    6,   /* 249 f9 */
    6,   /* 250 fa */
    7,   /* 251 fb */
    6,   /* 252 fc */
    7,   /* 253 fd */
    7,   /* 254 fe */
    8};  /* 255 ff */
